<template>
  <div class="grid__sort-list">
    <FormSelect
      placeholder="Order by"
      :options="sortList"
      @onSelectChange="handleSortListUpdate"
    />
  </div>
</template>
<script lang="ts">
import _ from 'lodash';
import Vue from 'vue';
import { Component, Inject } from 'vue-property-decorator';
import { SortItem } from '@/types';
import { FormSelect } from '@/components/atoms';
import { namespace } from 'vuex-class';

const grid = namespace('grid');

@Component({
  components: { FormSelect },
})
export default class GridSort extends Vue {
  @Inject('gridSortList') private sortList!: Array<SortItem>;

  @grid.Action
  public setGridSort!: (sortItem: SortItem) => void;

  handleSortListUpdate(selectedValue: string) {
    const sortBy = _.find(this.sortList, { id: selectedValue });
    this.setGridSort(sortBy);
  }
}
</script>
